--=============================================================================--
-- ★ 创建角色窗口类
--=============================================================================--

创建角色窗口类 = class()



--=============================================================================--
-- ■ 构造函数()
--=============================================================================--

function 创建角色窗口类:初始化()

      self.背景图片 = 引擎:载入图片("Dat/创建角色背景.png")
      self.背景精灵 = D2D_精灵.创建(self.背景图片,0,0,640,480)


      self.性别按钮 = D2D_按钮.创建("Dat/箭头按钮.png",160,188)
      self.发型按钮 = D2D_按钮.创建("Dat/箭头按钮.png",160,214)
      self.眼睛按钮 = D2D_按钮.创建("Dat/箭头按钮.png",160,240)
      self.肤色按钮 = D2D_按钮.创建("Dat/箭头按钮.png",160,266)
      
      self.左方向按钮 = D2D_按钮.创建("Dat/左方向按钮.png",270,246)
      self.右方向按钮 = D2D_按钮.创建("Dat/右方向按钮.png",345,246)
      self.下一步按钮 = D2D_按钮.创建("Dat/建立角色下一步按钮.png",283,391)

      self.角色名输入框 =  D2D_输入框.创建(100,ARGB(255,255,255,255),"宋体",15,false,false,false,10,false,false,false)

      
      self.方向= 1

      self.衣服_男_图片 = 引擎:载入图片("Dat/avatar/衣服/001.png")
      self.衣服_女_图片 = 引擎:载入图片("Dat/avatar/衣服/003.png")

      self.肤色_图片1 = 引擎:载入图片("Dat/avatar/皮肤/001.png")
      self.肤色_图片2 = 引擎:载入图片("Dat/avatar/皮肤/002.png")

      self.眼睛_图片1 = 引擎:载入图片("Dat/avatar/眼睛/001.png")
      self.眼睛_图片2 = 引擎:载入图片("Dat/avatar/眼睛/002.png")

      self.发型_男_图片1 = 引擎:载入图片("Dat/avatar/发型/003.png")
      self.发型_男_图片2 = 引擎:载入图片("Dat/avatar/发型/004.png")
      
      self.发型_女_图片1 = 引擎:载入图片("Dat/avatar/发型/001.png")
      self.发型_女_图片2 = 引擎:载入图片("Dat/avatar/发型/002.png")
      

      self.角色_动画 = D2D_动画.创建(self.肤色_图片1,16,8,0,0,32,48)
      self.角色_动画:播放()



      self.性别 = "帅哥"
      self.发型 = "发型1"
      self.眼睛 = "眼睛1"
      self.肤色 = "肤色1"
      self.衣服 = "001.png" 
	
	 游戏进度  = "角色创建"

end



--=============================================================================--
-- ■ 更新()
--=============================================================================--

function 创建角色窗口类:更新(dt)

      self.性别按钮:更新()
      self.发型按钮:更新()
      self.眼睛按钮:更新()
      self.肤色按钮:更新()
      self.左方向按钮:更新()
      self.右方向按钮:更新()
      self.下一步按钮:更新()

      self.角色名输入框:更新(dt) 
      



     if (self.下一步按钮:取是否单击())then



             local 临时 = self.角色名输入框:取文本()
             
             
             if (string.len(临时) < 3) then
                 if (string.len(临时) == 0 )then

                    全局_提示框:弹出("请先给角色取个名字!")
                    return 
                 end

                全局_提示框:弹出("角色名太短了!")
                return 
             end


             if(判断是否有特殊字符(临时))   then

                 全局_提示框:弹出("角色含有非法字符!请勿使用空格以及特殊字符!\n请重新输入!")

             else


               if (self.性别 == "帅哥" ) then
                      if (self.发型 == "发型1") then
                          self.发型_后 = "003.png"
                      else
                          self.发型_后 = "004.png"
                      end
			    
			    self.衣服_后 = "001.png"
               end



               if (self.性别 == "美女") then
		   
				if (self.发型 == "发型1") then
					self.发型_后 = "001.png"
				else
					self.发型_后 = "002.png"
				end
			   
				self.衣服_后 = "003.png"
               end



               if (self.眼睛 == "眼睛1") then
                    self.眼睛_后 = "001.png"
               else
                   self.眼睛_后 = "002.png"
               end

               if (self.肤色 == "肤色1") then
                    self.肤色_后 = "001.png"
               else
                   self.肤色_后 = "002.png"
               end

											
		选择角色窗口 = 选择角色窗口类.创建(临时,"1",self.性别,self.发型_后,self.衣服_后,self.眼睛_后,self.肤色_后)






             end


     end

      

      
      
      



     if (self.左方向按钮:取是否单击())then

           self.方向= self.方向 +1
           
            if (self.方向 > 4) then
               self.方向 = 1
            end

     end

      
     if (self.右方向按钮:取是否单击())then

           self.方向= self.方向 - 1

            if (self.方向 < 1) then
               self.方向 = 4
            end

     end


     if (self.性别按钮:取是否单击())then

            if(self.性别 == "帅哥" ) then
                self.性别 = "美女"
            else
                self.性别 = "帅哥"
            end
     end



     if (self.发型按钮:取是否单击())then

            if(self.发型 == "发型1" ) then
                self.发型 = "发型2"
            else
                self.发型 = "发型1"
            end

     end
     




     if (self.眼睛按钮:取是否单击())then

            if(self.眼睛 == "眼睛1" ) then
                self.眼睛 = "眼睛2"
            else
                self.眼睛 = "眼睛1"
            end

     end
     
     

     if (self.肤色按钮:取是否单击())then

            if(self.肤色 == "肤色1" ) then
                self.肤色 = "肤色2"
            else
                self.肤色 = "肤色1"
            end

     end
     






     self.角色_动画:更新(dt)



                if (self.方向 == 1) then
                   
                       if(self.角色_动画:取当前帧() > 3 ) then
                            self:动画同步(0)
                       end


               elseif (self.方向 == 2) then

                       if(self.角色_动画:取当前帧() < 3 or self.角色_动画:取当前帧() > 7 ) then
                            self:动画同步(4)

                       end


               elseif (self.方向 == 3) then

                       if(self.角色_动画:取当前帧() < 11 or self.角色_动画:取当前帧() > 15 ) then
                            self:动画同步(12)
                       end

               elseif (self.方向 == 4) then

                       if(self.角色_动画:取当前帧() < 7 or self.角色_动画:取当前帧() > 11 ) then
                            self:动画同步(8)
                       end

              end
     

     
     

     
     



end



function 创建角色窗口类:动画同步(n)

            self.角色_动画:置当前帧(n)


end





--=============================================================================--
-- ■ 显示()
--=============================================================================--

function 创建角色窗口类:显示()


     self.背景精灵:显示()

     self.性别按钮:显示()
     self.发型按钮:显示()
     self.眼睛按钮:显示()
     self.肤色按钮:显示()
     self.左方向按钮:显示()
     self.右方向按钮:显示()
     self.下一步按钮:显示()
     
     文字:显示(112,190,self.性别)
     文字:显示(112,216,self.发型)
     文字:显示(112,244,self.眼睛)
     文字:显示(112,269,self.肤色)


     self.角色名输入框:显示(266,358)
     



            if(self.肤色 == "肤色1" ) then
                self.角色_动画:置图片(self.肤色_图片1)
            else
                self.角色_动画:置图片(self.肤色_图片2)
            end


     self.角色_动画:显示_高级(295,200,0,1.2,1.2)






            if(self.眼睛 == "眼睛1" ) then
                self.角色_动画:置图片(self.眼睛_图片1)
            else
                self.角色_动画:置图片(self.眼睛_图片2)
            end



     self.角色_动画:显示_高级(295,200,0,1.2,1.2)
     
     
     
     

            if(self.性别 == "帅哥" ) then
                self.角色_动画:置图片(self.衣服_男_图片)
            else
                self.角色_动画:置图片(self.衣服_女_图片)
            end


     
      self.角色_动画:显示_高级(295,200,0,1.2,1.2)





            if(self.发型 == "发型1" ) then

                  if(self.性别 == "帅哥" ) then
                       self.角色_动画:置图片(self.发型_男_图片1)
                  else
                       self.角色_动画:置图片(self.发型_女_图片1)
                  end
                

            else
            
                  if(self.性别 == "帅哥" ) then
                       self.角色_动画:置图片(self.发型_男_图片2)
                  else
                       self.角色_动画:置图片(self.发型_女_图片2)
                  end

            end






     self.角色_动画:显示_高级(295,200,0,1.2,1.2)


     
    文字:显示(295+ (36-文字:取宽度(self.角色名输入框:取文本()))/2  ,185,self.角色名输入框:取文本())
     
     


end


--=============================================================================--
-- ■ 销毁()
--=============================================================================--

function 创建角色窗口类:销毁()

      引擎:销毁图片(self.背景图片)
      self.背景精灵:销毁()


      self.左方向按钮:销毁()
      self.右方向按钮:销毁()
      self.下一步按钮:销毁()
      self.角色名输入框:销毁()
      
      
      引擎:销毁图片(self.衣服_男_图片)
      引擎:销毁图片(self.衣服_女_图片)
      引擎:销毁图片(self.肤色_图片1)
      引擎:销毁图片(self.肤色_图片2)
      引擎:销毁图片(self.眼睛_图片1)
      引擎:销毁图片(self.眼睛_图片2)
      引擎:销毁图片(self.发型_男_图片1)
      引擎:销毁图片(self.发型_男_图片2)
      引擎:销毁图片(self.发型_女_图片1)
      引擎:销毁图片(self.发型_女_图片2)

      self.角色_动画:销毁()


end


